Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Allocator Class Reference

Interface for a dynamic memory allocator that uses inheritance and dynamic binding to provide extensible mechanisms for allocating and deallocating memory. More...

`#include <Malloc_Base.h>`

Inheritance diagram for ACE_Allocator

[legend]
Collaboration diagram for ACE_Allocator:

[legend]
List of all members.

## Public Methods
| ACE_Allocator (void)
| "No-op" constructor (needed to make certain compilers happy).
virtual | ~ACE_Allocator (void)
| Virtual destructor.
virtual void* | malloc (size_t nbytes) = 0
| Allocate <nbytes>, but don't give them any initial value.
virtual void* | calloc (size_t nbytes, char initial_value = '\0') = 0
| Allocate <nbytes>, giving them <initial_value>.
virtual void* | calloc (size_t n_elem, size_t elem_size, char initial_value = '\0') = 0
| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>.
virtual void | free (void *ptr) = 0
| Free <ptr> (must have been allocated by ).
virtual int | remove (void) = 0
| Remove any resources associated with this memory manager.
virtual int | bind (const char *name, void *pointer, int duplicates = 0) = 0
virtual int | trybind (const char *name, void *&pointer) = 0
virtual int | find (const char *name, void *&pointer) = 0
| Locate <name> and pass out parameter via pointer. If found, return 0, Returns -1 if failure occurs.
virtual int | find (const char *name) = 0
| returns 0 if the name is in the mapping. -1, otherwise.
virtual int | unbind (const char *name) = 0
| Unbind (remove) the name from the map. Don't return the pointer to the caller.
virtual int | unbind (const char *name, void *&pointer) = 0
| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory.
virtual int | sync (ssize_t len = -1, int flags = MS_SYNC) = 0
virtual int | sync (void *addr, size_t len, int flags = MS_SYNC) = 0
| Sync <len> bytes of the memory region to the backing store starting at .
virtual int | protect (ssize_t len = -1, int prot = PROT_RDWR) = 0
virtual int | protect (void *addr, size_t len, int prot = PROT_RDWR) = 0
| Change the protection of the pages of the mapped region to <prot> starting at up to <len> bytes.
virtual void | dump (void) const = 0
| Dump the state of the object.
## Static Public Methods
ACE_Allocator* | instance (void)
| Get pointer to a default .
ACE_Allocator* | instance (ACE_Allocator *)
| Set pointer to a process-wide and return existing pointer.
void | close_singleton (void)
| Delete the dynamically allocated Singleton.
## Static Private Attributes
ACE_Allocator* | allocator_ = 0
| Pointer to a process-wide instance.
int | delete_allocator_ = 0
| Must delete the if non-0.

## Detailed Description

Interface for a dynamic memory allocator that uses inheritance and dynamic binding to provide extensible mechanisms for allocating and deallocating memory.

## Constructor & Destructor Documentation

ACE_Allocator::ACE_Allocator ( | void )

| "No-op" constructor (needed to make certain compilers happy).

ACE_Allocator::~ACE_Allocator ( | void )`[virtual]`

| Virtual destructor.

## Member Function Documentation

int ACE_Allocator::bind ( | const char * name,
| void * pointer,
| int duplicates = 0 )`[pure virtual]`

| Associate <name> with <pointer>. If <duplicates> == 0 then do not allow duplicate <name>/<pointer> associations, else if <duplicates> != 0 then allow duplicate <name>/<pointer> assocations. Returns 0 if successfully binds (1) a previously unbound <name> or (2) <duplicates> != 0, returns 1 if trying to bind a previously bound <name> and <duplicates> == 0, else returns -1 if a resource failure occurs. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

void * ACE_Allocator::calloc ( | size_t n_elem,
| size_t elem_size,
| char initial_value = '\0' )`[pure virtual]`

| Allocate <n_elem> each of size <elem_size>, giving them <initial_value>. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, ACE_Cached_Allocator, and ACE_Allocator_Adapter.

void * ACE_Allocator::calloc ( | size_t nbytes,
| char initial_value = '\0' )`[pure virtual]`

| Allocate <nbytes>, giving them <initial_value>. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, ACE_Cached_Allocator, and ACE_Allocator_Adapter.

void ACE_Allocator::close_singleton ( | void )`[static]`

| Delete the dynamically allocated Singleton.

void ACE_Allocator::dump ( | void ) const`[pure virtual]`

| Dump the state of the object. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::find ( | const char * name )`[pure virtual]`

| returns 0 if the name is in the mapping. -1, otherwise. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::find ( | const char * name,
| void *& pointer )`[pure virtual]`

| Locate <name> and pass out parameter via pointer. If found, return 0, Returns -1 if failure occurs. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

void ACE_Allocator::free ( | void * ptr )`[pure virtual]`

| Free <ptr> (must have been allocated by ). Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, ACE_Cached_Allocator, and ACE_Allocator_Adapter.

ACE_Allocator * ACE_Allocator::instance ( | ACE_Allocator * r )`[static]`

| Set pointer to a process-wide and return existing pointer.

ACE_Allocator * ACE_Allocator::instance ( | void )`[inline, static]`

| Get pointer to a default .

void * ACE_Allocator::malloc ( | size_t nbytes )`[pure virtual]`

| Allocate <nbytes>, but don't give them any initial value. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, ACE_Cached_Allocator, and ACE_Allocator_Adapter.

int ACE_Allocator::protect ( | void * addr,
| size_t len,
| int prot = PROT_RDWR )`[pure virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at up to <len> bytes. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::protect ( | ssize_t len = -1,
| int prot = PROT_RDWR )`[pure virtual]`

| Change the protection of the pages of the mapped region to <prot> starting at <this->base_addr_> up to <len> bytes. If <len> == -1 then change protection of all pages in the mapped region. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::remove ( | void )`[pure virtual]`

| Remove any resources associated with this memory manager. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::sync ( | void * addr,
| size_t len,
| int flags = MS_SYNC )`[pure virtual]`

| Sync <len> bytes of the memory region to the backing store starting at . Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::sync ( | ssize_t len = -1,
| int flags = MS_SYNC )`[pure virtual]`

| Sync <len> bytes of the memory region to the backing store starting at <this->base_addr_>. If <len> == -1 then sync the whole region. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::trybind ( | const char * name,
| void *& pointer )`[pure virtual]`

| Associate <name> with <pointer>. Does not allow duplicate <name>/<pointer> associations. Returns 0 if successfully binds (1) a previously unbound <name>, 1 if trying to bind a previously bound <name>, or returns -1 if a resource failure occurs. When this call returns <pointer>'s value will always reference the void * that <name> is associated with. Thus, if the caller needs to use <pointer> (e.g., to free it) a copy must be maintained by the caller. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::unbind ( | const char * name,
| void *& pointer )`[pure virtual]`

| Break any association of name. Returns the value of pointer in case the caller needs to deallocate memory. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

int ACE_Allocator::unbind ( | const char * name )`[pure virtual]`

| Unbind (remove) the name from the map. Don't return the pointer to the caller. Reimplemented in ACE_New_Allocator, ACE_Static_Allocator_Base, and ACE_Allocator_Adapter.

## Member Data Documentation

ACE_Allocator * ACE_Allocator::allocator_ = 0`[inline, static, private]`

| Pointer to a process-wide instance. Reimplemented in ACE_Allocator_Adapter.

int ACE_Allocator::delete_allocator_ = 0`[static, private]`

| Must delete the if non-0.

The documentation for this class was generated from the following files:

- Malloc_Base.h
- Malloc.cpp
- Malloc_Allocator.cpp